using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Diagram;

namespace HierarchicalTreeLayout
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MenuItem miOpenArrow;
		private System.Windows.Forms.MenuItem miFilledArrow;
		private System.Windows.Forms.MenuItem miOpenDiamond;
		private System.Windows.Forms.MenuItem miFilledDiamond;
		private System.Windows.Forms.MenuItem miOpenCircle;
		private System.Windows.Forms.ContextMenu LinkShapecontextMenu;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem miClosedCircle;
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram;
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
			InitializeDiagramNodes();
		}

		// Add the child symbols to the diagram and connect the symbols to form the diagram graph. 
		// This method uses individual Node postioning to lay out the nodes in the form of a vertical tree.
		protected void InitializeDiagramNodes()
		{
			Syncfusion.Windows.Forms.Diagram.InsertNodesCmd cmd = new Syncfusion.Windows.Forms.Diagram.InsertNodesCmd();

			#region		// Add TextNode Symbol to Diagram
			// Add a TextNode to highlight the subnode feature
			Syncfusion.Windows.Forms.Diagram.TextNode txtnode = new TextNode();
			txtnode.Text = "Hierarchical Tree Layout";
			txtnode.FontStyle.Size = 15;
			txtnode.FontStyle.Bold = true;
			txtnode.FontStyle.Family = "Arial";
			cmd.AddNode(txtnode,new PointF(225,25));
			this.diagram.Controller.ExecuteCommand(cmd);
			cmd.Nodes.Clear();

		
			// Draw the Node symbol.
			MyTextSymbol mysymbolA = new MyTextSymbol("Node A");
			cmd.AddNode(mysymbolA,new PointF(300,75));
			diagram.Controller.ExecuteCommand(cmd);			

			MyTextSymbol mysymbolB = new MyTextSymbol("Node B");			
			cmd.Nodes.Clear();
			cmd.AddNode(mysymbolB,new PointF(150, 155));
			diagram.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolB1 = new MyTextSymbol("Node B1");			
			cmd.Nodes.Clear();
			cmd.AddNode(mysymbolB1,new PointF(75, 255));
			diagram.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolB11 = new MyTextSymbol("Node B11");			
			cmd.Nodes.Clear();
			cmd.AddNode(mysymbolB11,new PointF(75, 345));
			diagram.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolB2 = new MyTextSymbol("Node B2");			
			cmd.Nodes.Clear();
			cmd.AddNode(mysymbolB2,new PointF(200, 255));
			diagram.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolB21 = new MyTextSymbol("Node B21");			
			cmd.Nodes.Clear();
			cmd.AddNode(mysymbolB21,new PointF(200, 345));
			diagram.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolC = new MyTextSymbol("Node C");			
			cmd.Nodes.Clear();
			cmd.AddNode(mysymbolC,new PointF(450, 155));
			diagram.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolC1 = new MyTextSymbol("Node C1");			
			cmd.Nodes.Clear();
			cmd.AddNode(mysymbolC1,new PointF(400, 255));
			diagram.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolC11 = new MyTextSymbol("Node C11");			
			cmd.Nodes.Clear();
			cmd.AddNode(mysymbolC11,new PointF(400, 345));
			diagram.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolC2 = new MyTextSymbol("Node C2");			
			cmd.Nodes.Clear();
			cmd.AddNode(mysymbolC2,new PointF(525, 255));
			diagram.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolC21 = new MyTextSymbol("Node C21");			
			cmd.Nodes.Clear();
			cmd.AddNode(mysymbolC21,new PointF(525, 345));
			diagram.Controller.ExecuteCommand(cmd);

			#endregion

			#region		// Draw links between the Symbols.

			
			LinkCmd lnkcmd = new LinkCmd();
			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.OrthogonalLine);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolA.leftport;
			lnkcmd.TargetPort = mysymbolB.rightport;			
			diagram.Controller.ExecuteCommand(lnkcmd);

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.OrthogonalLine);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolA.rightport;
			lnkcmd.TargetPort = mysymbolC.leftport;
			diagram.Controller.ExecuteCommand(lnkcmd);	
		
			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.OrthogonalLine);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolB.leftport;
			lnkcmd.TargetPort = mysymbolB1.leftport;
			diagram.Controller.ExecuteCommand(lnkcmd);	

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.OrthogonalLine);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolB.rightport;
			lnkcmd.TargetPort = mysymbolB2.rightport;
			diagram.Controller.ExecuteCommand(lnkcmd);	

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.OrthogonalLine);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolB1.CenterPort;
			lnkcmd.TargetPort = mysymbolB11.CenterPort;
			diagram.Controller.ExecuteCommand(lnkcmd);	

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.OrthogonalLine);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolB2.CenterPort;
			lnkcmd.TargetPort = mysymbolB21.CenterPort;
			diagram.Controller.ExecuteCommand(lnkcmd);	

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.OrthogonalLine);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolC.leftport;
			lnkcmd.TargetPort = mysymbolC1.leftport;
			diagram.Controller.ExecuteCommand(lnkcmd);	

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.OrthogonalLine);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolC.rightport;
			lnkcmd.TargetPort = mysymbolC2.rightport;
			diagram.Controller.ExecuteCommand(lnkcmd);	

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.OrthogonalLine);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolC1.CenterPort;
			lnkcmd.TargetPort = mysymbolC11.CenterPort;
			diagram.Controller.ExecuteCommand(lnkcmd);	

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.OrthogonalLine);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolC2.CenterPort;
			lnkcmd.TargetPort = mysymbolC21.CenterPort;
			diagram.Controller.ExecuteCommand(lnkcmd);	

			#endregion

		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.diagram = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.LinkShapecontextMenu = new System.Windows.Forms.ContextMenu();
			this.miOpenArrow = new System.Windows.Forms.MenuItem();
			this.miFilledArrow = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.miOpenDiamond = new System.Windows.Forms.MenuItem();
			this.miFilledDiamond = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.miOpenCircle = new System.Windows.Forms.MenuItem();
			this.miClosedCircle = new System.Windows.Forms.MenuItem();
			((System.ComponentModel.ISupportInitialize)(this.diagram)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.diagram.Model)).BeginInit();
			this.SuspendLayout();
			// 
			// diagram
			// 
			this.diagram.AllowDrop = true;
			// 
			// diagram.Controller
			// 
			this.diagram.Controller.MaxHistory = 256;
			this.diagram.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagram.HScroll = true;
			this.diagram.LayoutManager = null;
			this.diagram.Location = new System.Drawing.Point(0, 0);
			// 
			// diagram.Model
			// 
			this.diagram.Model.BackgroundStyle.Color = System.Drawing.Color.Snow;
			this.diagram.Model.BackgroundStyle.ForeColor = System.Drawing.Color.Azure;
			this.diagram.Model.HeaderFooterData.Footer.Bounds.Width = 650F;
			this.diagram.Model.HeaderFooterData.Header.Bounds.Width = 650F;
			this.diagram.Model.Height = 1056F;
			this.diagram.Model.Name = "Model";
			this.diagram.Model.ShadowStyle.AlphaFactor = 128;
			this.diagram.Model.ShadowStyle.Color = System.Drawing.Color.LightGray;
			this.diagram.Model.ShadowStyle.OffsetX = 6F;
			this.diagram.Model.ShadowStyle.OffsetY = 6F;
			this.diagram.Model.ShadowStyle.Visible = false;
			this.diagram.Model.Width = 816F;
			this.diagram.Name = "diagram";
			this.diagram.Size = new System.Drawing.Size(688, 470);
			this.diagram.SmartSizeBox = false;
			this.diagram.TabIndex = 0;
			this.diagram.Text = "diagram";
			// 
			// diagram.View
			// 
			this.diagram.View.Grid.Visible = false;
			this.diagram.VScroll = true;
			// 
			// LinkShapecontextMenu
			// 
			this.LinkShapecontextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																								 this.miOpenArrow,
																								 this.miFilledArrow,
																								 this.menuItem2,
																								 this.miOpenDiamond,
																								 this.miFilledDiamond,
																								 this.menuItem3,
																								 this.miOpenCircle,
																								 this.miClosedCircle});
			// 
			// miOpenArrow
			// 
			this.miOpenArrow.Index = 0;
			this.miOpenArrow.Text = "OpenArrow";
			this.miOpenArrow.Click += new System.EventHandler(this.miOpenArrow_Click);
			// 
			// miFilledArrow
			// 
			this.miFilledArrow.Index = 1;
			this.miFilledArrow.Text = "FilledArrow";
			this.miFilledArrow.Click += new System.EventHandler(this.miFilledArrow_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 2;
			this.menuItem2.Text = "-";
			// 
			// miOpenDiamond
			// 
			this.miOpenDiamond.Index = 3;
			this.miOpenDiamond.Text = "Open Diamond";
			this.miOpenDiamond.Click += new System.EventHandler(this.miOpenDiamond_Click);
			// 
			// miFilledDiamond
			// 
			this.miFilledDiamond.Index = 4;
			this.miFilledDiamond.Text = "Filled Diamond";
			this.miFilledDiamond.Click += new System.EventHandler(this.miFilledDiamond_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 5;
			this.menuItem3.Text = "-";
			// 
			// miOpenCircle
			// 
			this.miOpenCircle.Index = 6;
			this.miOpenCircle.Text = "Open Circle";
			this.miOpenCircle.Click += new System.EventHandler(this.miOpenCircle_Click);
			// 
			// miClosedCircle
			// 
			this.miClosedCircle.Index = 7;
			this.miClosedCircle.Text = "Closed Circle";
			this.miClosedCircle.Click += new System.EventHandler(this.miClosedCircle_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(688, 470);
			this.ContextMenu = this.LinkShapecontextMenu;
			this.Controls.Add(this.diagram);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.diagram.Model)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.diagram)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		private void miOpenArrow_Click(object sender, System.EventArgs e)
		{
			if(this.diagram.Controller.SelectionList.First is  Link)
			{
				Link link = this.diagram.Controller.SelectionList.First as Link;
				if(link != null)
				{
					EndPointDecoratorModel decoratorMdl;
					decoratorMdl = Global.EndPointDecoratorPalette["Open Arrow"];
					if (decoratorMdl != null)
						link.EndPoints.LastEndPointDecorator = decoratorMdl.CreateInstance();
				}
			}
		
		}

		private void miFilledArrow_Click(object sender, System.EventArgs e)
		{
			if(this.diagram.Controller.SelectionList.First is  Link)
			{
				Link link = this.diagram.Controller.SelectionList.First as Link;
				if(link != null)
				{
					EndPointDecoratorModel decoratorMdl;
					decoratorMdl = Global.EndPointDecoratorPalette["Filled Arrow"];
					if (decoratorMdl != null)
						link.EndPoints.LastEndPointDecorator = decoratorMdl.CreateInstance();
				}
			}
		
		}

		private void miOpenDiamond_Click(object sender, System.EventArgs e)
		{
		
			if(this.diagram.Controller.SelectionList.First is  Link)
			{
				Link link = this.diagram.Controller.SelectionList.First as Link;
				if(link != null)
				{
					EndPointDecoratorModel decoratorMdl;
					decoratorMdl = Global.EndPointDecoratorPalette["Open Diamond"];
					if (decoratorMdl != null)
						link.EndPoints.LastEndPointDecorator = decoratorMdl.CreateInstance();
				}
			}
		}

		private void miFilledDiamond_Click(object sender, System.EventArgs e)
		{
			if(this.diagram.Controller.SelectionList.First is  Link)
			{
				Link link = this.diagram.Controller.SelectionList.First as Link;
				if(link != null)
				{
					EndPointDecoratorModel decoratorMdl;
					decoratorMdl = Global.EndPointDecoratorPalette["Filled Diamond"];
					if (decoratorMdl != null)
						link.EndPoints.LastEndPointDecorator = decoratorMdl.CreateInstance();
				}
			}
		}

		private void miOpenCircle_Click(object sender, System.EventArgs e)
		{
			if(this.diagram.Controller.SelectionList.First is  Link)
			{
				Link link = this.diagram.Controller.SelectionList.First as Link;
				if(link != null)
				{
					EndPointDecoratorModel decoratorMdl;
					decoratorMdl = Global.EndPointDecoratorPalette["Open Circle"];
					if (decoratorMdl != null)
						link.EndPoints.LastEndPointDecorator = decoratorMdl.CreateInstance();
				}
			}
		}

		private void miClosedCircle_Click(object sender, System.EventArgs e)
		{
			if(this.diagram.Controller.SelectionList.First is  Link)
			{
				Link link = this.diagram.Controller.SelectionList.First as Link;
				if(link != null)
				{
					EndPointDecoratorModel decoratorMdl;
					decoratorMdl = Global.EndPointDecoratorPalette["Closed Circle"];
					if (decoratorMdl != null)
						link.EndPoints.LastEndPointDecorator = decoratorMdl.CreateInstance();
				}
			}
		}
	}
}
