using System;
using System.Drawing;
using System.Runtime.Serialization;
using Syncfusion.Windows.Forms.Diagram;

namespace HierarchicalTreeLayout
{
	/// <summary>
	/// Summary description for MyTextSymbol.
	/// </summary>
	[Serializable()]
	public class MyTextSymbol : Symbol
	{
		private Syncfusion.Windows.Forms.Diagram.Rectangle outerRect = null;
		public CirclePort leftport;
		public CirclePort rightport;
		public MyTextSymbol(string text)
		{
	
			// Add an outer rectangle
			this.outerRect = new Syncfusion.Windows.Forms.Diagram.Rectangle(0, 0, 75, 30);
			this.outerRect.Name = "Rectangle";
			this.outerRect.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.LinearGradient;
			this.outerRect.FillStyle.ForeColor = System.Drawing.Color.MistyRose;
			this.outerRect.FillStyle.Color = Color.Orange;
			this.AppendChild(outerRect);

			// Add Label to the Rectangle.
			Label lbl = this.AddLabel(text, BoxPosition.Center);
			lbl.Name = "Label";
			lbl.BackgroundStyle.Color = Color.Transparent;
			lbl.ReadOnly = true;

			// Port locations.
			leftport = new CirclePort(new PointF(0, this.Height / 2));
			rightport = new CirclePort(new PointF(this.Width, this.Height / 2));

			this.leftport.AttachAtPerimeter = true;
			this.rightport.AttachAtPerimeter = true;

			// Append CirlePorts to MySymbol.
			AppendChild(leftport);
			AppendChild(rightport);
		}
	}
}
